var call_requests_triggered = [];
var call_requests_open = [];
var actualCall = "";

(
    function()
    {
        var   macpDashboardUpdater,
              macpWebSocket

        macpDashboardUpdater =
        {
            update: function(oData, sType)
            {
                Object.keys(oData).forEach
                (
                    function(sKey)
                    {
                        var eElement

                        eElement = document.querySelector("#" + sKey)
                        if(eElement !== null)
                        {
                            switch(sType)
                            {
                                case "css":
                                    eElement.setAttribute("style", oData[sKey])
                                    break
                                case "data":
                                    eElement.innerHTML = oData[sKey]
                                    break
                            }
                        }
                    }.bind(this)
                )
            }
        }
        macpWebSocket =
        {
            oWebSocket: null,

            onConnected: function()
            {
            },
            onDisconnected: function()
            {
                this.initialize()
            },
            onError: function()
            {
                //alert('on error event');
                document.getElementById('stat_ws').style.backgroundColor='red;';
            },
            onMessage: function(sMessage)
            {
                var oData

                oData = JSON.parse(sMessage.data)

                switch(oData.action)
                {
                  case "trigger_callrequests":
                    tData = oData["data"];

                    call_requests_open = tData;
                    actualCall = oData["data_call"];

                    updateAreas();

                    $.each(tData, function(index, cr) {
                      if(!call_requests_triggered[cr.cr_id]){
                        call_requests_triggered[cr.cr_id] = cr;
                        $('#areas').click();

                        setTimeout(function(){
                          request('loadByExt',{"ext": cr.cl_src});
                        }, 1000);

                      }
                    });

                    break

                  case "open_call_requests":
                          call_requests_open = tData = oData["data"];
                          break
                  case "main_wrapper_reload":
                        macp_main_wrapper_reload()
                        break
                  case "reload":
                        this.oWebSocket.close()
                        window.location.reload(true)
                        break
                  case "update_dashboard":

                        if(typeof oData.dash_data === "object") {
                            macpDashboardUpdater.update(oData.dash_data, "data");
                        }

                        if(typeof oData.dash_css === "object")
                        {
                            macpDashboardUpdater.update(oData.dash_css, "css");
                        }
                        break
                }
            },

            initialize: function() 
            {
                this.oWebSocket = new WebSocket("ws://192.168.44.71:40000")

                this.oWebSocket.onopen    = this.onConnected.bind(this)
                this.oWebSocket.onerror    = this.onError.bind(this)
                this.oWebSocket.onmessage    = this.onMessage.bind(this)
                this.oWebSocket.onclose    = this.onDisconnected.bind(this)

                return this
            }
        }

        document.addEventListener("DOMContentLoaded", function(){macpWebSocket.initialize()})
    }()
)
